<?php
/**
 * @package Joomla
 * @subpackage Abook
 * @copyright (C) 2010 Ugolotti Federica
 * @license GNU/GPL, see LICENSE.php
 * EventList is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.

 * Abook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Abook; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

$mainframe->registerEvent( 'onSearch', 'plgSearchAbook' );
$mainframe->registerEvent( 'onSearchAreas', 'plgSearchAbookAreas' );
 
JPlugin::loadLanguage( 'plg_search_abook' );

function &plgSearchaBookAreas()
{
        static $areas = array(
                'abook' => 'book'
        );
        return $areas;
}

function plgSearchAbook( $text, $phrase='', $ordering='', $areas=null )
{
        $db            =& JFactory::getDBO();
        $user  =& JFactory::getUser(); 
 
require_once(JPATH_SITE.DS.'components'.DS.'com_abook'.DS.'router.php');
//If the array is not correct, return it:
        if (is_array( $areas )) {
                if (!array_intersect( $areas, array_keys( plgSearchAbookAreas() ) )) {
                        return array();
                }
        }

//It is time to define the parameters! First get the right plugin; 'search' (the group), 'nameofplugin'. 
$plugin =& JPluginHelper::getPlugin('search', 'abook');
 
//Then load the parameters of the plugin..
$pluginParams = new JParameter( $plugin->params );
 
//And define the parameters. For example like this..
$limit = $pluginParams->def( 'search_limit', 50 );
 
//Use the function trim to delete spaces in front of or at the back of the searching terms
$text = trim( $text );
 
//Return Array when nothing was filled in
if ($text == '') {
                return array();
        }
 
//After this, you have to add the database part. This will be the most difficult part, because this changes per situation.
//In the coding examples later on you will find some of the examples used by Joomla! 1.5 core Search Plugins.
//It will look something like this.
        $wheres = array();
        switch ($phrase) {
 
//search exact
                case 'exact':
                        $text          = $db->Quote( '%'.$db->getEscaped( $text, true ).'%', false );
                        $wheres2       = array();
                        $wheres2[]   = 'LOWER(a.title) LIKE '.$text;
			$wheres2[]   = 'LOWER(a.html) LIKE '.$text;
                        $where                 = '(' . implode( ') OR (', $wheres2 ) . ')';
                        break;
 
//search all or any
                case 'all':
                case 'any':
 
//set default
                default:
                        $words         = explode( ' ', $text );
                        $wheres = array();
                        foreach ($words as $word)
                        {
                                $word          = $db->Quote( '%'.$db->getEscaped( $word, true ).'%', false );
                                $wheres2       = array();
                                $wheres2[]   = 'LOWER(a.title) LIKE '.$word;
				$wheres2[]   = 'LOWER(a.html) LIKE '.$word;
                                $wheres[]    = implode( ' OR ', $wheres2 );
                        }
                        $where = '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')';
                        break;
        }
 
//ordering of the results
        switch ( $ordering ) {
 
//alphabetic, ascending
                case 'alpha':
                        $order = 'a.title ASC';
                        break;
 
//oldest first
                case 'oldest':
 
//popular first
                case 'popular':
 
//newest first
                case 'newest':
 
//default setting: alphabetic, ascending
                default:
                        $order = 'a.title ASC';
        }
 
//replace nameofplugin
        $searchAbook = JText::_( 'Book' );
 
//the database query; differs per situation! It will look something like this:
        $query = 'SELECT a.title AS title, a.html AS text,'
        . ' CONCAT_WS( " / ", '. $db->Quote($searchAbook) .', b.title )AS section,'
	. ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(\':\', a.id, a.alias) ELSE a.id END as slug,'
	. ' CASE WHEN CHAR_LENGTH(b.alias) THEN CONCAT_WS(\':\', b.id, b.alias) ELSE b.id END as catslug,'
        . ' "1" AS browsernav'
        . ' FROM #__abbook AS a'
        . ' INNER JOIN #__abcategories AS b ON b.id = a.catid'
        . ' WHERE ( '. $where .' )'
        . ' AND a.published = 1'
        . ' AND b.access <= '. (int) $user->get( 'aid' )
        . ' ORDER BY '. $order
        ;
//Set query
        $db->setQuery( $query, 0, $limit );
        $rows = $db->loadObjectList();
 
//The 'output' of the displayed link
        foreach($rows as $key => $row) {
                $rows[$key]->href = 'index.php?option=com_abook&view=book&catid='.$row->catslug.'&id='.$row->slug;
        }
 
//Return the search results in an array
return $rows;
}

